require "actors/player"
function love.load()
    screen_width = love.graphics.getWidth() 
    screen_height = love.graphics.getHeight()
    P = Player.new(16, 16)
    map_width = 16
    map_height = 16
    tile_size = 32
    fov = math.pi / 4
    screen = {}
    map = {
        {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, },
        {1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 1, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1, },
        {1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1, },
        {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, }}
    hits = {}
end

function love.update(dt)
    P:move(dt)
    
end

function love.draw()



    for y, xs in ipairs(map) do 
        for x, value in ipairs(xs) do 
            if value == 1 then 
                love.graphics.rectangle("fill", (x-1)*tile_size, (y-1)*tile_size, tile_size, tile_size)
            end
        end
    end
    P:draw()
    RayCast()


    for i, h in ipairs(hits) do 
        love.graphics.setColor(0, 1, 0)
        love.graphics.circle("fill", h.x, h.y, 3, 3)
        love.graphics.setColor(1, 1, 1)
    end
    love.graphics.setColor(0, 0, 0)
    love.graphics.print(love.timer.getFPS())
    love.graphics.setColor(1, 1,1)
end

function RayCast()
    for rayn=0, 90 do --later adjustable by fov slider
        local ray = {x, y, a, range, maxrange, mapX, mapY} 
        ray.maxrange = 8   
        ray.range = 0
        ray.a = P.a - math.rad(45) + math.rad(rayn)
        ray.x = P.x + math.cos(ray.a) * 32
        ray.y = P.y + math.sin(ray.a) * 32
        ray.x = roundToMultiple(ray.x, 32, -1)
        ray.mapX = ray.x / 32
        ray.mapY = roundToMultiple(ray.y, 32, 1) / 32
        while ray.range < ray.maxrange do
            if ray.mapY > 0 and ray.mapY < 17 and ray.mapX > 0 and ray.mapX < 17 then 
                if map[ray.mapY][ray.mapX] == 1 or map[ray.mapY][ray.mapX + 1] == 1 then
                    ray.range = 8 
                else --if no wall was hit, extend ray and try again until wall is hit or range hits maxrange
                    ray.x = P.x + math.cos(ray.a) * 32 * ray.range
                    ray.y = P.y + math.sin(ray.a) * 32 * ray.range
                    ray.x = roundToMultiple(ray.x, 32, 1)
                    ray.mapX = ray.x / 32
                    ray.mapY = roundToMultiple(ray.y, 32, 1) / 32
                    ray.range = ray.range + 1
                end
            else 
                ray.range = 8
            end
        end
        
        
        
        love.graphics.setColor(1, 0, 0)
        love.graphics.line(P.x, P.y, ray.x, ray.y ) 
        --these are meant to later just skip vertical or horizontal checks if the ray is completly one of these
        if ray.a == math.pi/2 or ray.a == 3*math.pi/2 then --vertical
        elseif ray.a == math.pi or ray.a == 0 then --horizontal
        elseif ray.a < math.pi/2 or ray.a > 3*math.pi/2 then --right
        elseif ray.a > math.pi/2 and ray.a < 3*math.pi/2 then --left
        end
    love.graphics.setColor(1, 1, 1)

    end
end

function roundToMultiple(v, m, dir) 
    --horrible, horrible code to round v(the number passed in) to the next multiple of m(multiple) 
    --dir is supposed to dictate if the number  65 would get down to 64 or up to 128
    v=math.floor(v)
    while(v%m < 0 or v%m > 0) do 
        v = v + dir
    end
    return v
end